Klappen3 = {};

function Klappen3.prerequisitesPresent(specializations)
    return true;
end;

function Klappen3:load(xmlFile)

self.setRotateDirection4= SpecializationUtil.callSpecializationsFunction("setRotateDirection4");  -- setRotation wäre hier irreführend weils die funktion von Giants schon gibt, nimm lieder die hier. Mit dem aufruf registrierst du die funktion.

local rotationPartNodeRotation4= Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Rotation4#index"));
    if rotationPartNodeRotation4 ~= nil then
        self.Rotation4 = {};
        self.Rotation4.node = rotationPartNodeRotation4;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rotation4#minRot"));
        self.Rotation4.minRot = {};
        self.Rotation4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rotation4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rotation4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rotation4#maxRot"));
        self.Rotation4.maxRot = {};
        self.Rotation4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rotation4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rotation4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Rotation4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Rotation4#rotTime"), 2)*1000;
    end;

  self.currentRotationDir4= false; -- die aktuelle richtung der drehung als Boolean(wahrheitswert)
end;

function Klappen3:delete()
end;

function Klappen3:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Klappen3:keyEvent(unicode, sym, modifier, isDown)
       if isDown and sym == Input.KEY_z then
             self:setRotateDirection4(not self.currentRotationDir4); -- tastenevents sollte man als funktion auslagern, um MP-sachen zu vereinfachen. Beim tastendruck wird eben die funktion aufgerufen nur eben mit dem genau anderen wert :D
      end;
      end;
function Klappen3:readStream(streamId, connection)  -- wird Aufgerufen wenn ich selber ein Spiel join
     self:setRotateDirection4(streamReadBool(streamId), true);  -- ich rufe also vom server die aktuelle richtung ab. True ist hier wichtig, weil ich will ja nur an meinem rechner den wert haben, und nich an alle anderen Mitspiele das Event schicken (weil die haben den aktuellen wert ja schon :-)) Das true hier also nie vergessen
end;

function Klappen3:writeStream(streamId, connection)  -- wird am Server aufgerufen wenn ein Spieler joint
    streamWriteBool(streamId, self.currentRotationDir4);   -- Wenn einspieler joint möchte ich ihm die aktuelle rotationsrichtung übertragen
end;

function Klappen3:update(dt)
end;


function Klappen3:updateTick(dt)  -- ist wie Update nur verzögert um performance zu sparen. Prinzipiell sollte alles hier rein, bis auf sachen für die die verzögerung nicht reihct(z.b. tastendruck etz)
	if self.Rotation4 ~= nil then
		local x, y, z = getRotation(self.Rotation4.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.Rotation4.maxRot, self.Rotation4.minRot, 3, self.Rotation4.rotTime, dt, not self.currentRotationDir4); -- hier habe ich nur drehen druch currentRotationDir2 ersetzt
		setRotation(self.Rotation4.node, unpack(newRot));
   end;
end;

function Klappen3:setRotateDirection4(newDirection, noEventSend)  -- noEventSend bedeutet , dass wenn die variable den wert true hat kein event an andere mitspieler gesendet werden soll
    RotationEvent3.sendEvent(self, newDirection, noEventSend);	-- wir versuchen das event zu senden. Als parameter übergeben wir die neue rotationDirection, die wir beim tastendruck setzen
    self.currentRotationDir4 = newDirection; -- wir setzen nun lokal die neue Richtung
end;
function Klappen3:draw()
end; 
